(*
 *  beware ircd, Internet Relay Chat server, b_clearmode.pas
 *  Copyright (C) 2002 Bas Steendijk
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *)

unit b_clearmode;

interface

uses buser,bstuff,bchannel,bconsts;

procedure m_clearmode(cptr,sptr:tuser;parc:integer;parv:pparams);

implementation

uses bcmds,blinklist,bconfig,bparse;

procedure m_clearmode(cptr,sptr:tuser;parc:integer;parv:pparams);
var
  s:string;
  ch:tchannel;
  a:integer;

procedure checkflag(chr:string;i:integer);
begin
  if pos(chr,s) <> 0 then if flag_isset(ch.modeflag,i) then begin
    ch.modeflag := ch.modeflag and not i;
  end;
end;

procedure checkuserchanflag(chr:string;i:integer);
var
  uc:tuserchan;
begin
  if pos(chr,s) = 0 then exit;
  uc := tuserchan(ch.user);
  while uc <> nil do begin
    if flag_isset(uc.flags,i) then begin
      uc.flags := uc.flags and not i;
    end;
    uc := tuserchan(uc.next2);
  end;
end;

procedure checkbanlist(chr:string;var list:tban);
var
  b:tban;
begin
  if pos(chr,s) = 0 then exit;
  while list <> nil do begin
    b := list;
    linklistdel(tlinklist(list),b);
    b.destroy;
  end;
end;

begin
  if (parc < 2) or (parv[1] = '') then exit;
  ch := findchan(parv[1]);
  if ch = nil then exit;
  if flag_isset(ch.flags,chanflag_modeless) then exit;

  if (parc < 3) or (parv[2] = '') then begin
    s := schanmodesupported; {string which contains all possible channel modes}
  end else begin
    s := parv[2];
  end;

  {clear flags}
  for a := 0 to maxchanmodetable do checkflag(chanmodetable[a].c,chanmodetable[a].flag);

  {clear ops/voice}
  checkuserchanflag('o',userchanflag_op);
  checkuserchanflag('v',userchanflag_voice);

  {clear bans}
  checkbanlist('b',ch.banlist);

  {clear key, limit}
  if pos('k',s) <> 0 then if ch.key <> '' then begin
    ch.key := '';
  end;

  {clear key, limit}
  if pos('l',s) <> 0 then if ch.limit <> 0 then begin
    ch.limit := 0;
  end;
end;


end.
