(*
 *  bserv, Internet Relay Chat services, bcmds.pas
 *  Copyright (C) 2002 Bas Steendijk
 *
 *  some modifications by peter green
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *)
unit bcmds;

interface

uses bstuff;

const
  numcmds=67;

MFLG_UNREG=1;
MFLG_IGNORE=2;
mflg_rawstr=4;

MSG_PRIVMSG= 'PRIVMSG';
TOK_PRIVMSG= 'P';

MSG_NICK= 'NICK';
TOK_NICK= 'N';

MSG_NOTICE= 'NOTICE';
TOK_NOTICE= 'O';

MSG_JOIN= 'JOIN';
TOK_JOIN= 'J';

MSG_MODE= 'MODE';
TOK_MODE= 'M';

MSG_QUIT= 'QUIT';
TOK_QUIT= 'Q';

MSG_PART= 'PART';
TOK_PART= 'L';

MSG_TOPIC= 'TOPIC';
TOK_TOPIC= 'T';

MSG_INVITE= 'INVITE';
TOK_INVITE= 'I';

MSG_KICK= 'KICK';
TOK_KICK= 'K';

MSG_WALLOPS= 'WALLOPS';
TOK_WALLOPS= 'WA';

MSG_PING= 'PING';
TOK_PING= 'G';

MSG_PONG= 'PONG';
TOK_PONG= 'Z';

MSG_ERROR= 'ERROR';
TOK_ERROR= 'Y';

MSG_KILL= 'KILL';
TOK_KILL= 'D';

MSG_USER= 'USER';
TOK_USER= 'USER';

MSG_AWAY= 'AWAY';
TOK_AWAY= 'A';

MSG_ISON= 'ISON';
TOK_ISON= 'ISON';

MSG_SERVER= 'SERVER';
TOK_SERVER= 'S';

MSG_SQUIT= 'SQUIT';
TOK_SQUIT= 'SQ';

MSG_WHOIS= 'WHOIS';
TOK_WHOIS= 'W';

MSG_WHO= 'WHO';
TOK_WHO= 'H';

MSG_LIST= 'LIST';
TOK_LIST= 'LIST';

MSG_NAMES= 'NAMES';
TOK_NAMES= 'E';

MSG_USERHOST= 'USERHOST';
TOK_USERHOST= 'USERHOST';

MSG_PASS= 'PASS';
TOK_PASS= 'PA';

MSG_SILENCE= 'SILENCE';
TOK_SILENCE= 'U';

MSG_LUSERS= 'LUSERS';
TOK_LUSERS= 'LU';

MSG_TIME= 'TIME';
TOK_TIME= 'TI';

MSG_OPER= 'OPER';
TOK_OPER= 'OPER';

MSG_CONNECT= 'CONNECT';
TOK_CONNECT= 'CO';

MSG_VERSION= 'VERSION';
TOK_VERSION= 'V';

MSG_STATS= 'STATS';
TOK_STATS= 'R';

MSG_LINKS= 'LINKS';
TOK_LINKS= 'LI';

MSG_ADMIN= 'ADMIN';
TOK_ADMIN= 'AD';

MSG_NICKSERV= 'NICKSERV';
TOK_NICKSERV= 'NS';

MSG_CHANSERV= 'CHANSERV';
TOK_CHANSERV= 'CS';

MSG_MEMOSERV= 'MEMOSERV';
TOK_MEMOSERV= 'MS';

MSG_NS= 'NS';
TOK_NS= 'NS';

MSG_CS= 'CS';
TOK_CS= 'CS';

MSG_MS= 'MS';
TOK_MS= 'MS';

MSG_HELP= 'HELP';
TOK_HELP= 'HELP';

MSG_INFO= 'INFO';
TOK_INFO= 'F';

MSG_MOTD= 'MOTD';
TOK_MOTD= 'MO';

MSG_SETTIME= 'SETTIME';
TOK_SETTIME= 'SE';

MSG_REHASH= 'REHASH';
TOK_REHASH= 'REHASH';

MSG_MAP= 'MAP';
TOK_MAP= 'MAP';

MSG_RESTART= 'RESTART';
TOK_RESTART= 'RESTART';

MSG_DIE= 'DIE';
TOK_DIE= 'DIE';

MSG_GLINE= 'GLINE';
TOK_GLINE= 'GL';

MSG_SETHOST= 'SETHOST';
TOK_SETHOST= 'SETHOST';

MSG_SVSNICK= 'SVSNICK';
TOK_SVSNICK= 'SVSNICK';

MSG_WHOWAS= 'WHOWAS';
TOK_WHOWAS= 'X';

MSG_TRACE= 'TRACE';
TOK_TRACE= 'TR';

MSG_OPTIONS= 'OPTIONS';
TOK_OPTIONS= 'OPTIONS';

MSG_USERIP= 'USERIP';
TOK_USERIP= 'USERIP';

MSG_BURST= 'BURST';
TOK_BURST= 'B';

MSG_END_OF_BURST= 'END_OF_BURST';
TOK_END_OF_BURST= 'EB';

MSG_EOB_ACK= 'EOB_ACK';
TOK_EOB_ACK= 'EA';

MSG_CREATE= 'CREATE';
TOK_CREATE= 'C';

MSG_DESYNCH= 'DESYNCH';
TOK_DESYNCH= 'DS';

MSG_WALLCHOPS= 'WALLCHOPS';
TOK_WALLCHOPS= 'WC';

MSG_POST= 'POST';
TOK_POST= 'POST';

MSG_CPRIVMSG= 'CPRIVMSG';
TOK_CPRIVMSG= 'CPRIVMSG';

MSG_CNOTICE= 'CNOTICE';
TOK_CNOTICE= 'CNOTICE';

MSG_ACCOUNT= 'ACCOUNT';
TOK_ACCOUNT= 'AC';

MSG_OPMODE= 'OPMODE';
TOK_OPMODE= 'OM';

MSG_CLEARMODE= 'CLEARMODE';
TOK_CLEARMODE= 'CM';

cmdprivmsg=0;cmdnick=1;cmdnotice=2;cmdjoin=3;cmdmode=4;
cmdquit=5;cmdpart=6;cmdtopic=7;cmdinvite=8;cmdkick=9;
cmdwallops=10;cmdping=11;cmdpong=12;cmderror=13;cmdkill=14;
cmduser=15;cmdaway=16;cmdison=17;cmdserver=18;cmdsquit=19;
cmdwhois=20;cmdwho=21;cmdlist=22;cmdnames=23;cmduserhost=24;
cmdpass=25;cmdsilence=26;cmdlusers=27;cmdtime=28;cmdoper=29;
cmdconnect=30;cmdversion=31;cmdstats=32;cmdlinks=33;cmdadmin=34;
cmdnickserv=35;cmdchanserv=36;cmdmemoserv=37;cmdns=38;cmdcs=39;
cmdms=40;cmdhelp=41;cmdinfo=42;cmdmotd=43;cmdsettime=44;
cmdrehash=45;cmdmap=46;cmdrestart=47;cmddie=48;cmdgline=49;
cmdsethost=50;cmdsvsnick=51;cmdwhowas=52;cmdtrace=53;cmdoptions=54;
cmduserip=55;cmdburst=56;cmdendofburst=57;cmdeoback=58;cmdcreate=59;
cmddesynch=60;cmdwallchops=61;cmdcprivmsg=63;cmdpost=62;cmdcnotice=64;
cmdaccount=65;cmdopmode=66;cmdclearmode=67;


var
  cmdreverse:array[0..26*26-1] of integer;
  tokreverse:array[0..26*26-1] of integer;
  statsm:array[0..numcmds,0..1] of integer;

function getcmdreversenum(const s:string):integer;

implementation

uses bparse;

{convert a command to the number in the reverse lookup table
string must be non-null
}
function getcmdreversenum(const s:string):integer;
var
  a:integer;
begin
  a := byte(s[1]);
  case a of
    65..90:begin
      result := a-65;
    end;
  else
    result := 0;
  end;
  if length(s) >= 2 then begin
    a := byte(s[2]);
    case a of
      65..90:begin
        inc(result,26*(a-65));
      end;
    end;
  end;
end;

end.
